/*
 * Author: Jake G 
 * Date: 2024 
 * filename: LedController.c
 * description: Abstract LED interface and control.  
 */


#ifndef __AVR_ATtiny404__
#define __AVR_ATtiny404__
#endif

#include "LedController.h"
#include "avr/io.h"

#define PA_B1 (1<<2)
#define PA_B2 (1<<3)
#define PA_B3 (1<<6)
#define PA_B4 (1<<7)

#define BITS_IN_BYTE (1<<2)|(1<<3)|(1<<6)|(1<<7)

#define HALF_BYTE_BM 

typedef struct LedController {
    void *port;
    uint8_t pins[BITS_IN_BYTE];
}LedController;

static LedController controller;


void LedControler_SetPortADefault(void);


/*
 * Uses pins: 9, 8, 12, 13
 */
void LedControler_SetPortBDefault(void)
{
    //controller.port = &PORTA;
}

void LedController_SetLedBitNum(void * port, uint8_t pin, uint8_t bit);

void LedController_ShowByte(uint8_t byte);


void LedControler_ShowHalfByte(uint8_t byte)
{
    byte = byte & 0x0F;

    //PORTA.DIR |= (1<<2)|(1<<3)|(1<<6)|(1<<7);
    PORTA.DIR |= PA_B1;
    PORTA.DIR |= PA_B2;
    PORTA.DIR |= PA_B3;
    PORTA.DIR |= PA_B4;
    //PORTA.DIR |= HALF_BYTE_BM;

    // 15 = 0b1111
    //PORTA.OUT |= (byte & 0x0F);

    if(byte & 0x01){
        PORTA.OUT |= PA_B1;
    }
    if(byte & 0x02){
        PORTA.OUT |= PA_B2;
    }
    if(byte & 0x04){
        PORTA.OUT |= PA_B3;
    }
    if(byte & 0x08){
        PORTA.OUT |= PA_B4;
    }
}


void LedControler_ClearHalfByte(void)
{
    //PORTA.OUT &= HALF_BYTE_BM;
    //PORTA.OUT &= ~((1<<2)|(1<<3)|(1<<6)|(1<<7));
    PORTA.OUT &= ~PA_B1;
    PORTA.OUT &= ~PA_B2;
    PORTA.OUT &= ~PA_B3;
    PORTA.OUT &= ~PA_B4;
    //PORTA.OUT = 0x00;
}
